Package net.sf.saxon.trace

## Class AbstractTraceListener

- java.lang.Object
- - net.sf.saxon.lib.StandardDiagnostics
  - - net.sf.saxon.trace.AbstractTraceListener

- All Implemented Interfaces:
    `java.util.EventListener`, `TraceListener`
  Direct Known Subclasses:
    `ModeTraceListener`, `XQueryTraceListener`, `XSLTTraceListener`

      public abstract class AbstractTraceListener
      extends StandardDiagnostics
      implements TraceListener

  This is the standard trace listener used when the -T option is specified on the command line. There are two variants, represented by subclasses: one for XSLT, and one for XQuery. The two variants differ in that they present the trace output in terms of constructs used in the relevant host language.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected int` | `indent` |
    `protected Logger` | `out` |

    - ### Fields inherited from class net.sf.saxon.lib.StandardDiagnostics

      `MAX_MESSAGE_LENGTH, MAX_MESSAGE_LINE_LENGTH, MIN_MESSAGE_LINE_LENGTH, TARGET_MESSAGE_LINE_LENGTH`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `AbstractTraceListener()` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `close()` | Called at end
    `void` | `endCurrentItem​(Item item)` | Called after a node of the source tree got processed
    `void` | `endRuleSearch​(java.lang.Object rule, Mode mode, Item item)` | Method called when a rule search has completed.
    `void` | `enter​(Traceable info, java.util.Map<java.lang.String,​java.lang.Object> properties, XPathContext context)` | Called when an instruction in the stylesheet gets processed
    `java.lang.String` | `escape​(java.lang.String in)` | Escape a string for XML output (in an attribute delimited by double quotes).
    `CodeInjector` | `getCodeInjector()` | Get the associated CodeInjector to be used at compile time to generate the tracing calls
    `protected abstract java.lang.String` | `getOpeningAttributes()` |
    `Logger` | `getOutputDestination()` | Get the output destination
    `protected boolean` | `isApplicable​(Traceable info)` |
    `void` | `leave​(Traceable info)` | Called after an instruction of the stylesheet got processed
    `protected int` | `level​(Traceable info)` |
    `void` | `open​(Controller controller)` | Called at start
    `void` | `setLevelOfDetail​(int level)` | Set the level of detail required
    `void` | `setOutputDestination​(Logger stream)` | Set the output destination (default is System.err)
    `protected static java.lang.String` | `spaces​(int n)` | Get n spaces
    `void` | `startCurrentItem​(Item item)` | Called when an item becomes the context item
    `void` | `startRuleSearch()` | Method called when a search for a template rule is about to start
    `protected abstract java.lang.String` | `tag​(Traceable info)` |

    - ### Methods inherited from class net.sf.saxon.lib.StandardDiagnostics

      `abbreviateLocationURI, abbreviateLocationURIDefault, expandSpecialCharacters, formatListOfOffendingNodes, getInstructionName, getInstructionNameDefault, getLocationMessageText, printStackTrace, showOriginator, wordWrap`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### indent

          protected int indent

    - #### out

          protected Logger out

  - ### Constructor Detail

    - #### AbstractTraceListener

          public AbstractTraceListener()

  - ### Method Detail

    - #### getCodeInjector

          public CodeInjector getCodeInjector()

      Get the associated CodeInjector to be used at compile time to generate the tracing calls

    - #### setLevelOfDetail

          public void setLevelOfDetail​(int level)

      Set the level of detail required
      Parameters:
        `level` - 0=none, 1=low (function and template calls), 2=normal (instructions), 3=high (expressions)

    - #### open

          public void open​(Controller controller)

      Called at start
      Specified by:
        `open` in interface `TraceListener`
      Parameters:
        `controller` - identifies the transformation controller, and provides the listener with access to context and configuration information

    - #### getOpeningAttributes

          protected abstract java.lang.String getOpeningAttributes()

    - #### close

          public void close()

      Called at end
      Specified by:
        `close` in interface `TraceListener`

    - #### enter

          public void enter​(Traceable info,
                            java.util.Map<java.lang.String,​java.lang.Object> properties,
                            XPathContext context)

      Called when an instruction in the stylesheet gets processed
      Specified by:
        `enter` in interface `TraceListener`
      Parameters:
        `info` - gives information about the instruction being executed, and about the context in which it is executed. This object is mutable, so if information from the InstructionInfo is to be retained, it must be copied.
        `properties` - extra information about the instruction to be included in the trace
        `context` - the XPath evaluation context

    - #### escape

          public java.lang.String escape​(java.lang.String in)

      Escape a string for XML output (in an attribute delimited by double quotes). This method also collapses whitespace (since the value may be an XPath expression that was originally written over several lines).

    - #### leave

          public void leave​(Traceable info)

      Called after an instruction of the stylesheet got processed
      Specified by:
        `leave` in interface `TraceListener`
      Parameters:
        `info` -

    - #### isApplicable

          protected boolean isApplicable​(Traceable info)

    - #### tag

          protected abstract java.lang.String tag​(Traceable info)

    - #### level

          protected int level​(Traceable info)

    - #### startCurrentItem

          public void startCurrentItem​(Item item)

      Called when an item becomes the context item
      Specified by:
        `startCurrentItem` in interface `TraceListener`
      Parameters:
        `item` - the new current item. Item objects are not mutable; it is safe to retain a reference to the Item for later use.

    - #### endCurrentItem

          public void endCurrentItem​(Item item)

      Called after a node of the source tree got processed
      Specified by:
        `endCurrentItem` in interface `TraceListener`
      Parameters:
        `item` - the item that was current, whose processing is now complete. This will represent the same underlying item as the corresponding startCurrentItem() call, though it will not necessarily be the same actual object.

    - #### spaces

          protected static java.lang.String spaces​(int n)

      Get n spaces

    - #### setOutputDestination

          public void setOutputDestination​(Logger stream)

      Set the output destination (default is System.err)
      Specified by:
        `setOutputDestination` in interface `TraceListener`
      Parameters:
        `stream` - the output destination for tracing output

    - #### getOutputDestination

          public Logger getOutputDestination()

      Get the output destination

    - #### endRuleSearch

          public void endRuleSearch​(java.lang.Object rule,
                                    Mode mode,
                                    Item item)

      Method called when a rule search has completed.
      Specified by:
        `endRuleSearch` in interface `TraceListener`
      Parameters:
        `rule` - the rule (or possible built-in ruleset) that has been selected
        `mode` - the mode in operation
        `item` - the item that was checked against

    - #### startRuleSearch

          public void startRuleSearch()

      Method called when a search for a template rule is about to start
      Specified by:
        `startRuleSearch` in interface `TraceListener`